Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_export.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_export.py	(revision 9169)
@@ -44,10 +44,10 @@
             'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
             'firstname,lastname,matric_number,middlename,nationality,'
-            'perm_address,phone,reg_number,sex,student_id,password,'
+            'perm_address,phone,reg_number,sex,student_id,suspended,password,'
             'state,history,certcode\r\n'
 
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,M123456,M.,NG,"Studentroad 21\nLagos 123456\n",'
-            '+234-123-12345,123456,f,A111111,,created'
+            'Anna,Tester,234,M.,NG,"Studentroad 21\nLagos 123456\n",'
+            '+234-123-12345#,123,f,A111111,0,,created'
             in result
             )
@@ -64,10 +64,10 @@
             'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
             'firstname,lastname,matric_number,middlename,nationality,'
-            'perm_address,phone,reg_number,sex,student_id,password,'
+            'perm_address,phone,reg_number,sex,student_id,suspended,password,'
             'state,history,certcode\r\n'
 
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,M123456,M.,NG,"Studentroad 21\nLagos 123456\n",'
-            '+234-123-12345,123456,f,A111111,,created'
+            'Anna,Tester,234,M.,NG,"Studentroad 21\nLagos 123456\n",'
+            '+234-123-12345#,123,f,A111111,0,,created'
             in result
             )
@@ -83,10 +83,10 @@
             'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
             'firstname,lastname,matric_number,middlename,nationality,'
-            'perm_address,phone,reg_number,sex,student_id,password,'
+            'perm_address,phone,reg_number,sex,student_id,suspended,password,'
             'state,history,certcode\r\n'
 
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,M123456,M.,NG,"Studentroad 21\nLagos 123456\n",'
-            '+234-123-12345,123456,f,A111111,,created'
+            'Anna,Tester,234,M.,NG,"Studentroad 21\nLagos 123456\n",'
+            '+234-123-12345#,123,f,A111111,0,,created'
             in result
             )
@@ -127,5 +127,5 @@
             'entry_mode,entry_session,previous_verdict,student_id\r\n'
 
-            ',,,NY,,,NY,\r\n'
+            ',,,0,,,0,\r\n'
             )
         return
@@ -144,5 +144,5 @@
             'entry_mode,entry_session,previous_verdict,student_id\r\n'
 
-            'CERT1,200,2012,NY,ug_ft,2010,NY,A111111\r\n'
+            'CERT1,200,2012,0,ug_ft,2010,0,A111111\r\n'
             )
         return
@@ -160,5 +160,5 @@
             'entry_mode,entry_session,previous_verdict,student_id\r\n'
 
-            'CERT1,200,2012,NY,ug_ft,2010,NY,A111111\r\n'
+            'CERT1,200,2012,0,ug_ft,2010,0,A111111\r\n'
             )
         return
@@ -175,5 +175,5 @@
             'entry_mode,entry_session,previous_verdict,student_id\r\n'
 
-            'CERT1,200,2012,NY,ug_ft,2010,NY,A111111\r\n'
+            'CERT1,200,2012,0,ug_ft,2010,0,A111111\r\n'
             )
         return
@@ -209,6 +209,7 @@
         self.assertEqual(
             result,
-            'level,level_session,level_verdict,student_id\r\n'
-            ',,NY,\r\n'
+            'level,level_session,level_verdict,validated_by,validation_date,'
+            'student_id\r\n'
+            ',,0,,,\r\n'
             )
         return
@@ -225,6 +226,7 @@
         self.assertEqual(
             result,
-            'level,level_session,level_verdict,student_id\r\n'
-            '100,2012,A,A111111\r\n'
+            'level,level_session,level_verdict,validated_by,validation_date,'
+            'student_id\r\n'
+            '100,2012,A,,,A111111\r\n'
             )
         return
@@ -239,6 +241,7 @@
         self.assertEqual(
             result,
-            'level,level_session,level_verdict,student_id\r\n'
-            '100,2012,A,A111111\r\n'
+            'level,level_session,level_verdict,validated_by,validation_date,'
+            'student_id\r\n'
+            '100,2012,A,,,A111111\r\n'
             )
         return
@@ -252,6 +255,7 @@
         self.assertEqual(
             result,
-            'level,level_session,level_verdict,student_id\r\n'
-            '100,2012,A,A111111\r\n'
+            'level,level_session,level_verdict,validated_by,validation_date,'
+            'student_id\r\n'
+            '100,2012,A,,,A111111\r\n'
             )
         return
@@ -371,9 +375,9 @@
         self.assertEqual(
             result,
-            'ac,amount_auth,creation_date,p_category,p_id,'
+            'ac,amount_auth,creation_date,p_category,p_current,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
             'r_code,r_desc,student_id\r\n'
 
-            ',0.0,2012-04-01 13:12:01,schoolfee,,,,,unpaid,,0.0,,,\r\n'
+            ',0.0,2012-04-01 13:12:01,schoolfee,1,,,,,unpaid,,0.0,,,\r\n'
             )
         return
@@ -389,9 +393,9 @@
         self.assertEqual(
             result,
-            'ac,amount_auth,creation_date,p_category,p_id,'
+            'ac,amount_auth,creation_date,p_category,p_current,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
             'r_code,r_desc,student_id\r\n'
 
-            '666,0.0,2012-04-01 13:12:01,schoolfee,my-id,'
+            '666,0.0,2012-04-01 13:12:01,schoolfee,1,my-id,'
             'p-item,100,2012,unpaid,2012-04-01 14:12:01,12.12,'
             'r-code,,A111111\r\n'
@@ -408,9 +412,9 @@
         self.assertEqual(
             result,
-            'ac,amount_auth,creation_date,p_category,p_id,'
+            'ac,amount_auth,creation_date,p_category,p_current,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
             'r_code,r_desc,student_id\r\n'
 
-            '666,0.0,2012-04-01 13:12:01,schoolfee,my-id,'
+            '666,0.0,2012-04-01 13:12:01,schoolfee,1,my-id,'
             'p-item,100,2012,unpaid,2012-04-01 14:12:01,12.12,'
             'r-code,,A111111\r\n'
@@ -427,9 +431,9 @@
         self.assertEqual(
             result,
-            'ac,amount_auth,creation_date,p_category,p_id,'
+            'ac,amount_auth,creation_date,p_category,p_current,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
             'r_code,r_desc,student_id\r\n'
 
-            '666,0.0,2012-04-01 13:12:01,schoolfee,my-id,'
+            '666,0.0,2012-04-01 13:12:01,schoolfee,1,my-id,'
             'p-item,100,2012,unpaid,2012-04-01 14:12:01,12.12,'
             'r-code,,A111111\r\n'
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_student.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_student.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_student.py	(revision 9169)
@@ -21,9 +21,13 @@
 import re
 import unittest
+import grok
 from cStringIO import StringIO
 from datetime import tzinfo
-from zope.component import getUtility
+from zope.component import getUtility, queryUtility, createObject
+from zope.catalog.interfaces import ICatalog
 from zope.component.interfaces import IFactory
+from zope.event import notify
 from zope.interface import verify
+from zope.schema.interfaces import RequiredMissing
 from waeup.kofa.interfaces import IExtFileStore, IFileStoreNameChooser
 from waeup.kofa.students.export import EXPORTER_NAMES
@@ -129,5 +133,5 @@
         studylevel = StudentStudyLevel()
         self.assertRaises(
-            TypeError, studylevel.addCourseTicket, department)
+            TypeError, studylevel.addCourseTicket, department, department)
 
     def test_booking_date(self):
@@ -236,4 +240,84 @@
         return
 
+class StudentTransferTests(StudentImportExportSetup):
+
+    layer = FunctionalLayer
+
+    def setUp(self):
+        super(StudentTransferTests, self).setUp()
+
+        # Add additional certificate
+        self.certificate2 = createObject('waeup.Certificate')
+        self.certificate2.code = 'CERT2'
+        self.certificate2.application_category = 'basic'
+        self.certificate2.start_level = 200
+        self.certificate2.end_level = 500
+        self.app['faculties']['fac1']['dep1'].certificates.addCertificate(
+            self.certificate2)
+
+        # Add student with subobjects
+        student = Student()
+        self.app['students'].addStudent(student)
+        student = self.setup_student(student)
+        notify(grok.ObjectModifiedEvent(student))
+        self.student = self.app['students'][student.student_id]
+        return
+
+    def test_transfer_student(self):
+        self.assertRaises(
+            RequiredMissing, self.student.transfer, self.certificate2)
+        error = self.student.transfer(self.certificate2, current_session=1000)
+        self.assertTrue(error == -1)
+        error = self.student.transfer(self.certificate2, current_session=2013)
+        self.assertTrue(error == None)
+        self.assertEqual(self.student['studycourse_1'].certificate.code, 'CERT1')
+        self.assertEqual(self.student['studycourse'].certificate.code, 'CERT2')
+        self.assertEqual(self.student['studycourse_1'].current_session, 2012)
+        self.assertEqual(self.student['studycourse'].current_session, 2013)
+        self.assertEqual(self.student['studycourse'].entry_session,
+            self.student['studycourse_1'].entry_session)
+        self.assertEqual(self.student['studycourse_1'].__name__, 'studycourse_1')
+        logfile = os.path.join(
+            self.app['datacenter'].storage, 'logs', 'students.log')
+        logcontent = open(logfile).read()
+        self.assertTrue('system - K1000000 - transferred from CERT1 to CERT2'
+            in logcontent)
+        messages = ' '.join(self.student.history.messages)
+        self.assertMatches(
+            '...<YYYY-MM-DD hh:mm:ss> UTC - '
+            'Transferred from CERT1 to CERT2 by system', messages)
+
+        # The students_catalog has been updated.
+        cat = queryUtility(ICatalog, name='students_catalog')
+        results = cat.searchResults(certcode=('CERT1', 'CERT1'))
+        results = [x for x in results]
+        self.assertEqual(len(results), 0)
+        results = cat.searchResults(certcode=('CERT2', 'CERT2'))
+        results = [x for x in results]
+        self.assertEqual(len(results), 1)
+        assert results[0] is self.app['students'][self.student.student_id]
+        results = cat.searchResults(current_session=(2013,2013))
+        results = [x for x in results]
+        self.assertEqual(len(results), 1)
+        assert results[0] is self.app['students'][self.student.student_id]
+
+        # Students can be transferred (only) two times.
+        error = self.student.transfer(self.certificate,
+            current_session=2013)
+        self.assertTrue(error == None)
+        error = self.student.transfer(self.certificate2,
+            current_session=2013)
+        self.assertTrue(error == -3)
+        self.assertEqual([i for i in self.student.keys()],
+            [u'accommodation', u'payments', u'studycourse',
+             u'studycourse_1', u'studycourse_2'])
+
+        # The students_catalog has been updated again.
+        cat = queryUtility(ICatalog, name='students_catalog')
+        results = cat.searchResults(certcode=('CERT1', 'CERT1'))
+        results = [x for x in results]
+        self.assertEqual(len(results), 1)
+        assert results[0] is self.app['students'][self.student.student_id]
+        return
 
 class StudentFactoryTest(FunctionalTestCase):
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/utils.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/utils.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/utils.py	(revision 9169)
@@ -19,27 +19,17 @@
 """
 import grok
-from random import SystemRandom as r
 from time import time
-from datetime import datetime
-from zope.i18n import translate
-from zope.component import getUtility, createObject
-from reportlab.pdfgen import canvas
 from reportlab.lib import colors
 from reportlab.lib.units import cm
-from reportlab.lib.enums import TA_RIGHT
 from reportlab.lib.pagesizes import A4
-from reportlab.lib.styles import getSampleStyleSheet, ParagraphStyle
-from reportlab.platypus import (Frame, Paragraph, Image, PageBreak, Table,
-                                Spacer)
-from reportlab.platypus.tables import TableStyle
-from reportlab.platypus.flowables import PageBreak
-from zope.component import getUtility
+from reportlab.lib.styles import getSampleStyleSheet
+from reportlab.platypus import Paragraph, Image, Table, Spacer
+from zope.component import getUtility, createObject
 from zope.formlib.form import setUpEditWidgets
-
+from zope.i18n import translate
 from waeup.kofa.interfaces import (
     IExtFileStore, IKofaUtils, RETURNING, PAID, CLEARED)
 from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.students.interfaces import IStudentsUtils
-from waeup.kofa.utils.helpers import now
 
 SLIP_STYLE = [
@@ -127,6 +117,13 @@
     #data.append([Spacer(1, 12)])
     portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
+
+    f_label = formatted_label(size=12) % _('Name')
+    f_label = Paragraph(f_label, style["Normal"])
+    f_text = formatted_text(studentview.context.display_fullname, size=12)
+    f_text = Paragraph(f_text, style["Normal"])
+    data_right.append([f_label,f_text])
+
     for widget in studentview.widgets:
-        if widget.name == 'form.adm_code':
+        if 'name' in widget.name:
             continue
         f_label = formatted_label(size=12) % translate(
@@ -137,4 +134,12 @@
         f_text = Paragraph(f_text, style["Normal"])
         data_right.append([f_label,f_text])
+
+    if hasattr(studentview.context, 'certcode'):
+        f_label = formatted_label(size=12) % _('Study Course')
+        f_label = Paragraph(f_label, style["Normal"])
+        f_text = formatted_text(studentview.context.certcode, size=12)
+        f_text = Paragraph(f_text, style["Normal"])
+        data_right.append([f_label,f_text])
+
     table_left = Table(data_left,style=SLIP_STYLE)
     table_right = Table(data_right,style=SLIP_STYLE, colWidths=[5*cm, 6*cm])
@@ -165,4 +170,47 @@
     return table
 
+def get_signature_table(signatures, lang='en'):
+    """Return a reportlab table containing signature fields (with date).
+    """
+    style = getSampleStyleSheet()
+    space_width = 0.4  # width in cm of space between signatures
+    table_width = 16.0 # supposed width of signature table in cms
+    # width of signature cells in cm...
+    sig_col_width = table_width - ((len(signatures) - 1) * space_width)
+    sig_col_width = sig_col_width / len(signatures)
+    data = []
+    col_widths = [] # widths of columns
+
+    sig_style = [
+        ('VALIGN',(0,-1),(-1,-1),'TOP'),
+        ('FONT', (0,0), (-1,-1), 'Helvetica-BoldOblique', 12),
+        ('BOTTOMPADDING', (0,0), (-1,0), 36),
+        ('TOPPADDING', (0,-1), (-1,-1), 0),
+        ]
+    for num, elem in enumerate(signatures):
+        # draw a line above each signature cell (not: empty cells in between)
+        sig_style.append(
+            ('LINEABOVE', (num*2,-1), (num*2, -1), 1, colors.black))
+
+    row = []
+    for signature in signatures:
+        row.append(trans(_('Date:'), lang))
+        row.append('')
+        if len(signatures) > 1:
+            col_widths.extend([sig_col_width*cm, space_width*cm])
+        else:
+            col_widths.extend([sig_col_width/2*cm, sig_col_width/2*cm])
+            row.append('') # empty spaceholder on right
+    data.append(row[:-1])
+    data.extend(([''],)*3) # insert 3 empty rows...
+    row = []
+    for signature in signatures:
+        row.append(Paragraph(trans(signature, lang), style["Normal"]))
+        row.append('')
+    data.append(row[:-1])
+    table = Table(data, style=sig_style, repeatRows=len(data),
+                  colWidths=col_widths)
+    return table
+
 def docs_as_flowables(view, lang='en'):
     """Create reportlab flowables out of scanned docs.
@@ -190,7 +238,7 @@
             if img_path is None:
                 pass
-            elif not img_path.endswith('.jpg'):
+            elif not img_path[-4:] in ('.jpg', '.JPG'):
                 # reportlab requires jpg images, I think.
-                f_text = Paragraph('%s (Not displayable)' % (
+                f_text = Paragraph('%s (not displayable)' % (
                     viewlet.title,), ENTRY1_STYLE)
             else:
@@ -202,23 +250,4 @@
     return data
 
-def insert_footer(pdf,width,style,text=None, number_of_pages=1):
-      """Render the whole footer frame.
-      """
-      story = []
-      frame_footer = Frame(1*cm,0,width-(2*cm),1*cm)
-      tz = getUtility(IKofaUtils).tzinfo
-      timestamp = now(tz).strftime("%d/%m/%Y %H:%M:%S %Z")
-      left_text = '<font size=10>%s</font>' % timestamp
-      story.append(Paragraph(left_text, style["Normal"]))
-      frame_footer.addFromList(story,pdf)
-      story = []
-      frame_footer = Frame(1*cm,0,width-(2*cm),1*cm)
-      portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-      right_text = translate(_('<font size=10>${a} Page ${b} of ${c}</font>',
-          mapping = {'a':text, 'b':pdf.getPageNumber(), 'c':number_of_pages}),
-          'waeup.kofa', target_language=portal_language)
-      story.append(Paragraph(right_text, style["Right"]))
-      frame_footer.addFromList(story,pdf)
-
 class StudentsUtils(grok.GlobalUtility):
     """A collection of methods subject to customization.
@@ -227,5 +256,5 @@
 
     def getReturningData(self, student):
-        """ This method defines what happens after school fee payment
+        """ Define what happens after school fee payment
         depending on the student's senate verdict.
 
@@ -238,11 +267,9 @@
 
     def setReturningData(self, student):
-        """ This method defines what happens after school fee payment
-        depending on the student's senate verdict. It folllows
-        the same algorithm as getReturningData but it also sets the new
-        values
-
-        In the base configuration current level is always increased
-        by 100 no matter which verdict has been assigned.
+        """ Define what happens after school fee payment
+        depending on the student's senate verdict.
+
+        This method folllows the same algorithm as getReturningData but
+        it also sets the new values.
         """
         new_session, new_level = self.getReturningData(student)
@@ -250,19 +277,24 @@
         student['studycourse'].current_session = new_session
         verdict = student['studycourse'].current_verdict
-        student['studycourse'].current_verdict = 'NY'
+        student['studycourse'].current_verdict = '0'
         student['studycourse'].previous_verdict = verdict
         return
 
-    def setPaymentDetails(self, category, student):
+    def setPaymentDetails(self, category, student,
+            previous_session, previous_level):
         """Create Payment object and set the payment data of a student for
         the payment category specified.
 
         """
-        details = {}
         p_item = u''
         amount = 0.0
-        error = u''
-        p_session = student['studycourse'].current_session
-        p_level = student['studycourse'].current_level
+        if previous_session:
+            p_session = previous_session
+            p_level = previous_level
+            p_current = False
+        else:
+            p_session = student['studycourse'].current_session
+            p_level = student['studycourse'].current_level
+            p_current = True
         session = str(p_session)
         try:
@@ -276,17 +308,23 @@
             except (AttributeError, TypeError):
                 return _('Study course data are incomplete.'), None
-            if student.state == CLEARED:
-                amount = getattr(certificate, 'school_fee_1', 0.0)
-            elif student.state == RETURNING:
-                # In case of returning school fee payment the payment session
-                # and level contain the values of the session the student
-                # has paid for.
-                p_session, p_level = self.getReturningData(student)
-                amount = getattr(certificate, 'school_fee_2', 0.0)
-            elif student.is_postgrad and student.state == PAID:
-                # Returning postgraduate students also pay for the next session
-                # but their level always remains the same.
-                p_session += 1
-                amount = getattr(certificate, 'school_fee_2', 0.0)
+            if previous_session:
+                if previous_level == 100:
+                    amount = getattr(certificate, 'school_fee_1', 0.0)
+                else:
+                    amount = getattr(certificate, 'school_fee_2', 0.0)
+            else:
+                if student.state == CLEARED:
+                    amount = getattr(certificate, 'school_fee_1', 0.0)
+                elif student.state == RETURNING:
+                    # In case of returning school fee payment the payment session
+                    # and level contain the values of the session the student
+                    # has paid for.
+                    p_session, p_level = self.getReturningData(student)
+                    amount = getattr(certificate, 'school_fee_2', 0.0)
+                elif student.is_postgrad and student.state == PAID:
+                    # Returning postgraduate students also pay for the next session
+                    # but their level always remains the same.
+                    p_session += 1
+                    amount = getattr(certificate, 'school_fee_2', 0.0)
         elif category == 'clearance':
             p_item = student['studycourse'].certificate.code
@@ -296,5 +334,6 @@
             amount = academic_session.booking_fee
         if amount in (0.0, None):
-            return _(u'Amount could not be determined.'), None
+            return _('Amount could not be determined.' +
+                     ' Would you like to pay for a previous session?'), None
         for key in student['payments'].keys():
             ticket = student['payments'][key]
@@ -303,7 +342,8 @@
                ticket.p_item == p_item and \
                ticket.p_session == p_session:
-                  return _('This type of payment has already been made.'), None
+                  return _('This type of payment has already been made.' +
+                           ' Would you like to pay for a previous session?'), None
         payment = createObject(u'waeup.StudentOnlinePayment')
-        timestamp = "%d" % int(time()*1000)
+        timestamp = ("%d" % int(time()*10000))[1:]
         payment.p_id = "p%s" % timestamp
         payment.p_category = category
@@ -311,4 +351,5 @@
         payment.p_session = p_session
         payment.p_level = p_level
+        payment.p_current = p_current
         payment.amount_auth = amount
         return None, payment
@@ -333,5 +374,7 @@
             return
         end_level = certificate.end_level
-        if entry_session == grok.getSite()['hostels'].accommodation_session:
+        if current_level == 10:
+            bt = 'pr'
+        elif entry_session == grok.getSite()['hostels'].accommodation_session:
             bt = 'fr'
         elif current_level >= end_level:
@@ -357,5 +400,5 @@
     def renderPDF(self, view, filename='slip.pdf', student=None,
                   studentview=None, tableheader=None, tabledata=None,
-                  note=None):
+                  note=None, signatures=None):
         """Render pdf slips for various pages.
         """
@@ -373,4 +416,8 @@
             footer_text = "%s - %s - " % (student.student_id, footer_text)
 
+        # Insert history
+        if not filename.startswith('payment'):
+            data.extend(creator.fromStringList(student.history.messages))
+
         # Insert student data table
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
@@ -399,4 +446,10 @@
             contenttable = render_table_data(tableheader,tabledata)
             data.append(contenttable)
+
+        # Insert signatures
+        if signatures:
+            data.append(Spacer(1, 20))
+            signaturetable = get_signature_table(signatures)
+            data.append(signaturetable)
 
         view.response.setHeader(
@@ -412,5 +465,5 @@
 
     VERDICTS_DICT = {
-        'NY': _('(not yet)'),
+        '0': _('(not yet)'),
         'A': 'Successful student',
         'B': 'Student with carryover courses',
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/viewlets.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/viewlets.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/viewlets.py	(revision 9169)
@@ -1,3 +1,3 @@
-## $Id$
+3## $Id$
 ##
 ## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
@@ -166,4 +166,53 @@
     target = 'manage_base'
 
+class StudentTransfernButton(ManageActionButton):
+    grok.order(5)
+    grok.context(IStudent)
+    grok.view(StudentBaseDisplayFormPage)
+    grok.require('waeup.manageStudent')
+    text = _('Transfer student')
+    target = 'transfer'
+    icon = 'actionicon_redo.png'
+
+class StudentDeactivateActionButton(ManageActionButton):
+    grok.order(6)
+    grok.context(IStudent)
+    grok.view(StudentBaseDisplayFormPage)
+    grok.require('waeup.manageStudent')
+    text = _('Deactivate account')
+    target = 'deactivate'
+    icon = 'actionicon_traffic_lights_red.png'
+
+    @property
+    def target_url(self):
+        if self.context.suspended:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
+    @property
+    def onclick(self):
+        return "return window.confirm(%s);" % _(
+            "'A history message will be added. Are you sure?'")
+
+class StudentActivateActionButton(ManageActionButton):
+    grok.order(6)
+    grok.context(IStudent)
+    grok.view(StudentBaseDisplayFormPage)
+    grok.require('waeup.manageStudent')
+    text = _('Activate account')
+    target = 'activate'
+    icon = 'actionicon_traffic_lights_green.png'
+
+    @property
+    def target_url(self):
+        if not self.context.suspended:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
+    @property
+    def onclick(self):
+        return "return window.confirm(%s);" % _(
+            "'A history message will be added. Are you sure?'")
+
 class StudentClearanceManageActionButton(ManageActionButton):
     grok.order(1)
@@ -231,9 +280,17 @@
     target = 'view_personal'
 
+class StudentPersonalManageActionButton(ManageActionButton):
+    grok.order(1)
+    grok.context(IStudent)
+    grok.view(StudentPersonalDisplayFormPage)
+    grok.require('waeup.manageStudent')
+    text = _('Manage')
+    target = 'manage_personal'
+
 class StudentPersonalEditActionButton(ManageActionButton):
-    grok.order(1)
+    grok.order(2)
     grok.context(IStudent)
     grok.view(StudentPersonalDisplayFormPage)
-    grok.require('waeup.viewStudent')
+    grok.require('waeup.handleStudent')
     text = _('Edit')
     target = 'edit_personal'
@@ -247,4 +304,10 @@
     target = 'manage'
 
+    @property
+    def target_url(self):
+        if self.context.is_current:
+            return self.view.url(self.view.context, self.target)
+        return False
+
 class StudyLevelManageActionButton(ManageActionButton):
     grok.order(1)
@@ -254,4 +317,11 @@
     text = _('Manage')
     target = 'manage'
+
+    @property
+    def target_url(self):
+        is_current = self.context.__parent__.is_current
+        if not is_current:
+            return ''
+        return self.view.url(self.view.context, self.target)
 
 class StudentValidateCoursesActionButton(ManageActionButton):
@@ -266,6 +336,8 @@
     @property
     def target_url(self):
+        is_current = self.context.__parent__.is_current
         if self.context.student.state != REGISTERED or \
-            str(self.context.__parent__.current_level) != self.context.__name__:
+            str(self.context.__parent__.current_level) != self.context.__name__ or\
+            not is_current:
             return ''
         return self.view.url(self.view.context, self.target)
@@ -282,6 +354,8 @@
     @property
     def target_url(self):
+        is_current = self.context.__parent__.is_current
         if self.context.student.state not in (VALIDATED, REGISTERED) or \
-            str(self.context.__parent__.current_level) != self.context.__name__:
+            str(self.context.__parent__.current_level) != self.context.__name__ or\
+            not is_current:
             return ''
         return self.view.url(self.view.context, self.target)
@@ -296,4 +370,11 @@
     target = 'course_registration.pdf'
 
+    @property
+    def target_url(self):
+        is_current = self.context.__parent__.is_current
+        if not is_current:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
 class CourseTicketManageActionButton(ManageActionButton):
     grok.order(1)
@@ -313,5 +394,5 @@
 
 class PaymentReceiptActionButton(ManageActionButton):
-    grok.order(1)
+    grok.order(9) # This button should always be the last one.
     grok.context(IStudentOnlinePayment)
     grok.view(OnlinePaymentDisplayFormPage)
@@ -327,7 +408,6 @@
         return self.view.url(self.view.context, self.target)
 
-
 class ApprovePaymentActionButton(ManageActionButton):
-    grok.order(2)
+    grok.order(8)
     grok.context(IStudentOnlinePayment)
     grok.view(OnlinePaymentDisplayFormPage)
@@ -437,10 +517,10 @@
     grok.require('waeup.handleStudent')
     icon = 'actionicon_start.gif'
-    text = _('Start session')
+    text = _('Start new session')
     target = 'start_session'
 
     @property
     def target_url(self):
-        if self.context.next_session_allowed:
+        if self.context.next_session_allowed and self.context.is_current:
             return self.view.url(self.view.context, self.target)
         return False
@@ -460,5 +540,6 @@
         condition2 = str(student['studycourse'].current_level) in \
             self.view.context.keys()
-        if condition1 or condition2:
+        condition3 = not self.context.is_current
+        if condition1 or condition2 or condition3:
             return ''
         return self.view.url(self.view.context, self.target)
@@ -469,5 +550,5 @@
     grok.view(StudyLevelDisplayFormPage)
     grok.require('waeup.handleStudent')
-    text = _('Add and remove courses')
+    text = _('Edit course list')
     target = 'edit'
 
@@ -478,5 +559,6 @@
         condition2 = student[
             'studycourse'].current_level != self.view.context.level
-        if condition1 or condition2:
+        is_current = self.context.__parent__.is_current
+        if condition1 or condition2 or not is_current:
             return ''
         return self.view.url(self.view.context, self.target)
